--- old/usr/src/cmd/sendmail/src/daemon.c	Sat Feb  6 15:36:44 2016
+++ new/usr/src/cmd/sendmail/src/daemon.c	Sat Feb  6 15:36:44 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2007, 2009 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2007, 2009, 2010 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -14,7 +14,7 @@
 #include <sendmail.h>
 #include "map.h"
 
-SM_RCSID("@(#)$Id: daemon.c,v 8.683 2009/12/18 01:12:40 ca Exp $")
+SM_RCSID("@(#)$Id: daemon.c,v 8.698 2013-11-22 20:51:55 ca Exp $")
 
 #if defined(SOCK_STREAM) || defined(__GNU_LIBRARY__)
 # define USE_SOCK_STREAM	1
@@ -827,6 +827,7 @@
 			OutChannel = outchannel;
 			DisConnected = false;
 
+
 #if XLA
 			if (!xla_host_ok(RealHostName))
 			{
@@ -1267,7 +1268,8 @@
 	  case AF_INET6:
 		if (IN6_IS_ADDR_UNSPECIFIED(&daemonaddr->sin6.sin6_addr))
 			daemonaddr->sin6.sin6_addr =
-			    LocalDaemon ? in6addr_loopback : in6addr_any;
+			    (LocalDaemon && V6LoopbackAddrFound) ?
+			    in6addr_loopback : in6addr_any;
 		port = daemonaddr->sin6.sin6_port;
 		break;
 #endif /* NETINET6 */
@@ -2219,7 +2221,8 @@
 #if NETINET6
 		  case AF_INET6:
 			if (IN6_IS_ADDR_UNSPECIFIED(&clt_addr.sin6.sin6_addr))
-				clt_addr.sin6.sin6_addr = LocalDaemon ?
+				clt_addr.sin6.sin6_addr =
+					(LocalDaemon && V6LoopbackAddrFound) ?
 					in6addr_loopback : in6addr_any;
 			else
 				clt_bind = true;
@@ -2349,11 +2352,11 @@
 			/* check for name server timeouts */
 # if NETINET6
 			if (WorkAroundBrokenAAAA && family == AF_INET6 &&
-			    errno == ETIMEDOUT)
+			    (h_errno == TRY_AGAIN || errno == ETIMEDOUT))
 			{
 				/*
 				**  An attempt with family AF_INET may
-				**  succeed By skipping the next section
+				**  succeed. By skipping the next section
 				**  of code, we will try AF_INET before
 				**  failing.
 				*/
@@ -2665,6 +2668,7 @@
 #if NETINET
 			  case AF_INET:
 				addr.sin.sin_addr.s_addr = ConnectOnlyTo.sin.sin_addr.s_addr;
+				addr.sa.sa_family = ConnectOnlyTo.sa.sa_family;
 				break;
 #endif /* NETINET */
 
@@ -2872,7 +2876,10 @@
 
 	/* Use the configured HeloName as appropriate */
 	if (HeloName != NULL && HeloName[0] != '\0')
+	{
+		SM_FREE_CLR(mci->mci_heloname);
 		mci->mci_heloname = newstr(HeloName);
+	}
 
 	mci_setstat(mci, EX_OK, NULL, NULL);
 	return EX_OK;
@@ -4252,7 +4259,11 @@
 			return NULL;
 		dst += sz;
 		dst_len -= sz;
+# if _FFR_IPV6_FULL
+		ap = sm_inet6_ntop(s6a, dst, dst_len);
+# else /* _FFR_IPV6_FULL */
 		ap = (char *) inet_ntop(AF_INET6, s6a, dst, dst_len);
+# endif /* _FFR_IPV6_FULL */
 
 		/* Restore pointer to beginning of string */
 		if (ap != NULL)
@@ -4399,6 +4410,8 @@
 	saveretry = _res.retry;
 	if (_res.retry * _res.retrans > 20)
 		_res.retry = 20 / _res.retrans;
+	if (_res.retry == 0)
+		_res.retry = 1;
 # endif /* NAMED_BIND */
 
 	switch (sap->sa.sa_family)
--- old/usr/src/cmd/sendmail/src/daemon.h	Sat Feb  6 15:36:44 2016
+++ new/usr/src/cmd/sendmail/src/daemon.h	Sat Feb  6 15:36:44 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: daemon.h,v 8.3 2006/07/13 22:57:03 ca Exp $
+ *	$Id: daemon.h,v 8.4 2013-11-22 20:51:55 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifndef DAEMON_H
 #define DAEMON_H 1
 
--- old/usr/src/cmd/sendmail/src/deliver.c	Sat Feb  6 15:36:44 2016
+++ new/usr/src/cmd/sendmail/src/deliver.c	Sat Feb  6 15:36:44 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2008 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2010, 2012 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -14,7 +14,7 @@
 #include <sendmail.h>
 #include <sm/time.h>
 
-SM_RCSID("@(#)$Id: deliver.c,v 8.1020 2009/12/18 17:08:01 ca Exp $")
+SM_RCSID("@(#)$Id: deliver.c,v 8.1030 2013-11-22 20:51:55 ca Exp $")
 
 #if HASSETUSERCONTEXT
 # include <login_cap.h>
@@ -37,6 +37,7 @@
 static int	coloncmp __P((const char *, const char *));
 
 #if STARTTLS
+#  include <openssl/err.h>
 static int	starttls __P((MAILER *, MCI *, ENVELOPE *));
 static int	endtlsclt __P((MCI *));
 #endif /* STARTTLS */
@@ -1850,7 +1851,7 @@
 	**	If we are running SMTP, we just need to clean up.
 	*/
 
-	/* XXX this seems a bit wierd */
+	/* XXX this seems a bit weird */
 	if (ctladdr == NULL && m != ProgMailer && m != FileMailer &&
 	    bitset(QGOODUID, e->e_from.q_flags))
 		ctladdr = &e->e_from;
@@ -2144,6 +2145,7 @@
 			mci->mci_lastuse = curtime();
 			mci->mci_deliveries = 0;
 			mci->mci_exitstat = i;
+			mci_clr_extensions(mci);
 # if NAMED_BIND
 			mci->mci_herrno = h_errno;
 # endif /* NAMED_BIND */
@@ -2415,6 +2417,12 @@
 				else
 					pwd = sm_getpwnam(contextaddr->q_user);
 				sucflags = LOGIN_SETRESOURCES|LOGIN_SETPRIORITY;
+#ifdef LOGIN_SETCPUMASK
+				sucflags |= LOGIN_SETCPUMASK;
+#endif /* LOGIN_SETCPUMASK */
+#ifdef LOGIN_SETLOGINCLASS
+				sucflags |= LOGIN_SETLOGINCLASS;
+#endif /* LOGIN_SETLOGINCLASS */
 #ifdef LOGIN_SETMAC
 				sucflags |= LOGIN_SETMAC;
 #endif /* LOGIN_SETMAC */
@@ -3104,7 +3112,7 @@
 			    mci->mci_state != MCIS_CLOSED)
 			{
 				SET_HELO(mci->mci_flags);
-				mci->mci_flags &= ~MCIF_EXTENS;
+				mci_clr_extensions(mci);
 				goto reconnect;
 			}
 		}
@@ -3157,7 +3165,7 @@
 						     &mci->mci_out,
 						     mci->mci_conn, tmo) == 0)
 					{
-						mci->mci_flags &= ~MCIF_EXTENS;
+						mci_clr_extensions(mci);
 						mci->mci_flags |= MCIF_AUTHACT|
 								  MCIF_ONLY_EHLO;
 						goto reconnect;
@@ -4270,7 +4278,7 @@
 
 	/* pri: changes with each delivery attempt */
 	(void) sm_snprintf(bp, SPACELEFT(buf, bp), ", pri=%ld",
-		e->e_msgpriority);
+		PRT_NONNEGL(e->e_msgpriority));
 	bp += strlen(bp);
 
 	/* relay: max 66 bytes for IPv4 addresses */
@@ -6111,12 +6119,13 @@
 		return EX_TEMPFAIL;
 
 # if USE_OPENSSL_ENGINE
-	if (!SSL_set_engine(NULL))
+	if (!SSLEngineInitialized && !SSL_set_engine(NULL))
 	{
 		sm_syslog(LOG_ERR, NOQID,
 			  "STARTTLS=client, SSL_set_engine=failed");
 		return EX_TEMPFAIL;
 	}
+	SSLEngineInitialized = true;
 # endif /* USE_OPENSSL_ENGINE */
 
 	smtpmessage("STARTTLS", m, mci);
@@ -6150,7 +6159,7 @@
 			sm_syslog(LOG_ERR, NOQID,
 				  "STARTTLS=client, error: SSL_new failed");
 			if (LogLevel > 9)
-				tlslogerr("client");
+				tlslogerr(LOG_WARNING, "client");
 		}
 		return EX_SOFTWARE;
 	}
@@ -6169,7 +6178,7 @@
 				  "STARTTLS=client, error: SSL_set_xfd failed=%d",
 				  result);
 			if (LogLevel > 9)
-				tlslogerr("client");
+				tlslogerr(LOG_WARNING, "client");
 		}
 		return EX_SOFTWARE;
 	}
@@ -6189,11 +6198,17 @@
 
 		if (LogLevel > 5)
 		{
+			unsigned long l;
+			const char *sr;
+
+			l = ERR_peek_error();
+			sr = ERR_reason_error_string(l);
 			sm_syslog(LOG_WARNING, NOQID,
-				  "STARTTLS=client, error: connect failed=%d, SSL_error=%d, errno=%d, retry=%d",
-				  result, ssl_err, errno, i);
-			if (LogLevel > 8)
-				tlslogerr("client");
+				  "STARTTLS=client, error: connect failed=%d, reason=%s, SSL_error=%d, errno=%d, retry=%d",
+				  result, sr == NULL ? "unknown" : sr, ssl_err,
+				  errno, i);
+			if (LogLevel > 9)
+				tlslogerr(LOG_WARNING, "client");
 		}
 
 		SSL_free(clt_ssl);
--- old/usr/src/cmd/sendmail/src/domain.c	Sat Feb  6 15:36:44 2016
+++ new/usr/src/cmd/sendmail/src/domain.c	Sat Feb  6 15:36:44 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2004, 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2004, 2006, 2010 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1986, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,15 +11,13 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 #include "map.h"
 
 #if NAMED_BIND
-SM_RCSID("@(#)$Id: domain.c,v 8.202 2006/12/19 01:15:07 ca Exp $ (with name server)")
+SM_RCSID("@(#)$Id: domain.c,v 8.205 2013-11-22 20:51:55 ca Exp $ (with name server)")
 #else /* NAMED_BIND */
-SM_RCSID("@(#)$Id: domain.c,v 8.202 2006/12/19 01:15:07 ca Exp $ (without name server)")
+SM_RCSID("@(#)$Id: domain.c,v 8.205 2013-11-22 20:51:55 ca Exp $ (without name server)")
 #endif /* NAMED_BIND */
 
 #if NAMED_BIND
@@ -27,25 +25,6 @@
 # include <arpa/inet.h>
 
 
-/*
-**  The standard udp packet size PACKETSZ (512) is not sufficient for some
-**  nameserver answers containing very many resource records. The resolver
-**  may switch to tcp and retry if it detects udp packet overflow.
-**  Also note that the resolver routines res_query and res_search return
-**  the size of the *un*truncated answer in case the supplied answer buffer
-**  it not big enough to accommodate the entire answer.
-*/
-
-# ifndef MAXPACKET
-#  define MAXPACKET 8192	/* max packet size used internally by BIND */
-# endif /* ! MAXPACKET */
-
-typedef union
-{
-	HEADER		qb1;
-	unsigned char	qb2[MAXPACKET];
-} querybuf;
-
 # ifndef MXHOSTBUFSIZE
 #  define MXHOSTBUFSIZE	(128 * MAXMXHOSTS)
 # endif /* ! MXHOSTBUFSIZE */
--- old/usr/src/cmd/sendmail/src/envelope.c	Sat Feb  6 15:36:44 2016
+++ new/usr/src/cmd/sendmail/src/envelope.c	Sat Feb  6 15:36:44 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2003, 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2003, 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -13,7 +13,7 @@
 
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: envelope.c,v 8.310 2009/12/18 17:08:01 ca Exp $")
+SM_RCSID("@(#)$Id: envelope.c,v 8.313 2013-11-22 20:51:55 ca Exp $")
 
 /*
 **  CLRSESSENVELOPE -- clear session oriented data in an envelope
@@ -246,6 +246,7 @@
 		e->e_flags |= EF_FATALERRS|EF_CLRQUEUE;
 	}
 
+
 	e->e_flags &= ~EF_QUEUERUN;
 	for (q = e->e_sendqueue; q != NULL; q = q->q_next)
 	{
@@ -252,6 +253,7 @@
 		if (QS_IS_UNDELIVERED(q->q_state))
 			queueit = true;
 
+
 		/* see if a notification is needed */
 		if (bitset(QPINGONFAILURE, q->q_flags) &&
 		    ((IS_MSG_ERR(msg_timeout) &&
--- old/usr/src/cmd/sendmail/src/err.c	Sat Feb  6 15:36:45 2016
+++ new/usr/src/cmd/sendmail/src/err.c	Sat Feb  6 15:36:45 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2003 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2003, 2010 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,11 +11,9 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: err.c,v 8.196 2006/11/10 23:14:08 ca Exp $")
+SM_RCSID("@(#)$Id: err.c,v 8.206 2013-11-22 20:51:55 ca Exp $")
 
 #if LDAPMAP
 # include <lber.h>
@@ -361,7 +359,7 @@
 **		increments Errors.
 */
 
-/*VARARGS1*/
+/*VARARGS2*/
 void
 #ifdef __STDC__
 usrerrenh(char *enhsc, const char *fmt, ...)
@@ -429,6 +427,7 @@
 	if (QuickAbort)
 		sm_exc_raisenew_x(&EtypeQuickAbort, 1);
 }
+
 /*
 **  MESSAGE -- print message (not necessarily an error)
 **
@@ -475,11 +474,12 @@
 	  case '5':
 		if (CurEnv->e_rpool == NULL && CurEnv->e_message != NULL)
 			sm_free(CurEnv->e_message);
-		CurEnv->e_message =
-			sm_rpool_strdup_x(CurEnv->e_rpool, errtxt);
+		CurEnv->e_message = sm_rpool_strdup_x(CurEnv->e_rpool, errtxt);
 		break;
 	}
 }
+
+
 /*
 **  NMESSAGE -- print message (not necessarily an error)
 **
--- old/usr/src/cmd/sendmail/src/headers.c	Sat Feb  6 15:36:45 2016
+++ new/usr/src/cmd/sendmail/src/headers.c	Sat Feb  6 15:36:45 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2004, 2006, 2007 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2004, 2006, 2007 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -14,7 +14,7 @@
 #include <sendmail.h>
 #include <sm/sendmail.h>
 
-SM_RCSID("@(#)$Id: headers.c,v 8.317 2008/08/27 20:11:55 gshapiro Exp $")
+SM_RCSID("@(#)$Id: headers.c,v 8.320 2013-11-22 20:51:55 ca Exp $")
 
 static HDR	*allocheader __P((char *, char *, int, SM_RPOOL_T *, bool));
 static size_t	fix_mime_header __P((HDR *, ENVELOPE *));
@@ -377,11 +377,6 @@
 	if (!bitset(pflag, CHHDR_DEF) && !headeronly &&
 	    !bitset(EF_QUEUERUN, e->e_flags) && sm_strcasecmp(fname, p) == 0)
 	{
-		if (tTd(31, 2))
-		{
-			sm_dprintf("comparing header from (%s) against default (%s or %s)\n",
-				fvalue, e->e_from.q_paddr, e->e_from.q_user);
-		}
 		if (e->e_from.q_paddr != NULL &&
 		    e->e_from.q_mailer != NULL &&
 		    bitnset(M_LOCALMAILER, e->e_from.q_mailer->m_flags) &&
@@ -388,6 +383,12 @@
 		    (strcmp(fvalue, e->e_from.q_paddr) == 0 ||
 		     strcmp(fvalue, e->e_from.q_user) == 0))
 			dropfrom = true;
+		if (tTd(31, 2))
+		{
+			sm_dprintf("comparing header from (%s) against default (%s or %s), drop=%d\n",
+				fvalue, e->e_from.q_paddr, e->e_from.q_user,
+				dropfrom);
+		}
 	}
 
 	/* delete default value for this header */
@@ -406,6 +407,19 @@
 			{
 				/* make this look like the user entered it */
 				h->h_flags |= H_USER;
+
+				/*
+				**  If the MH hack is selected, allow to turn
+				**  it off via a mailer flag to avoid problems
+				**  with setups that remove the F flag from
+				**  the RCPT mailer.
+				*/
+
+		    		if (bitnset(M_NOMHHACK,
+					    e->e_from.q_mailer->m_flags))
+				{
+					h->h_flags &= ~H_CHECK;
+				}
 				return hi->hi_flags;
 			}
 			h->h_value = NULL;
@@ -1152,7 +1166,7 @@
 	(void) sm_snprintf(sbp, SPACELEFT(sbuf, sbp),
 		"from=%.200s, size=%ld, class=%d, nrcpts=%d",
 		e->e_from.q_paddr == NULL ? "<NONE>" : e->e_from.q_paddr,
-		e->e_msgsize, e->e_class, e->e_nrcpts);
+		PRT_NONNEGL(e->e_msgsize), e->e_class, e->e_nrcpts);
 	sbp += strlen(sbp);
 	if (msgid != NULL)
 	{
@@ -1191,7 +1205,7 @@
 							    83));
 	sm_syslog(LOG_INFO, e->e_id,
 		  "size=%ld, class=%ld, nrcpts=%d",
-		  e->e_msgsize, e->e_class, e->e_nrcpts);
+		  PRT_NONNEGL(e->e_msgsize), e->e_class, e->e_nrcpts);
 	if (msgid != NULL)
 		sm_syslog(LOG_INFO, e->e_id,
 			  "msgid=%s",
--- old/usr/src/cmd/sendmail/src/macro.c	Sat Feb  6 15:36:45 2016
+++ new/usr/src/cmd/sendmail/src/macro.c	Sat Feb  6 15:36:45 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2001, 2003, 2006, 2007 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2001, 2003, 2006, 2007 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,11 +11,9 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: macro.c,v 8.107 2007/08/06 22:29:02 ca Exp $")
+SM_RCSID("@(#)$Id: macro.c,v 8.108 2013-11-22 20:51:55 ca Exp $")
 
 #include <sm/sendmail.h>
 #if MAXMACROID != (BITMAPBITS - 1)
--- old/usr/src/cmd/sendmail/src/main.c	Sat Feb  6 15:36:45 2016
+++ new/usr/src/cmd/sendmail/src/main.c	Sat Feb  6 15:36:45 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2006, 2008, 2009 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2006, 2008, 2009, 2011 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,11 +11,6 @@
  *
  */
 
-/*
- * Copyright 1996-2006 Sun Microsystems, Inc.  All rights reserved.
- * Use is subject to license terms.
- */
-
 #define _DEFINE
 #include <sendmail.h>
 #include <sm/sendmail.h>
@@ -24,17 +19,16 @@
 
 #ifndef lint
 SM_UNUSED(static char copyright[]) =
-"@(#) Copyright (c) 1998-2003 Sendmail, Inc. and its suppliers.\n\
-@(#)	All rights reserved.\n\
-@(#) Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.\n\
-@(#) Copyright (c) 1988, 1993\n\
-@(#)	The Regents of the University of California.  All rights reserved.\n\
-@(#) Copyright 1996-2006 Sun Microsystems, Inc.  All rights reserved.\n\
-@(#) Use is subject to license terms.\n";
+"@(#) Copyright (c) 1998-2013 Proofpoint, Inc. and its suppliers.\n\
+	All rights reserved.\n\
+     Copyright (c) 1983, 1995-1997 Eric P. Allman.  All rights reserved.\n\
+     Copyright (c) 1988, 1993\n\
+	The Regents of the University of California.  All rights reserved.\n";
 #endif /* ! lint */
 
-SM_RCSID("@(#)$Id: main.c,v 8.971 2009/12/18 17:08:01 ca Exp $")
+SM_RCSID("@(#)$Id: main.c,v 8.988 2013-11-23 02:52:37 gshapiro Exp $")
 
+
 #if NETINET || NETINET6
 # include <arpa/inet.h>
 #endif /* NETINET || NETINET6 */
@@ -83,7 +77,7 @@
 **				(11/88 - 9/89).
 **			     UCB/Mammoth Project (10/89 - 7/95).
 **			     InReference, Inc. (8/95 - 1/97).
-**			     Sendmail, Inc. (1/98 - present).
+**			     Sendmail, Inc. (1/98 - 9/13).
 **		The support of my employers is gratefully acknowledged.
 **			Few of them (Britton-Lee in particular) have had
 **			anything to gain from my involvement in this project.
@@ -90,10 +84,12 @@
 **
 **		Gregory Neil Shapiro,
 **			Worcester Polytechnic Institute	(until 3/98).
-**			Sendmail, Inc. (3/98 - present).
+**			Sendmail, Inc. (3/98 - 10/13).
+**			Proofpoint, Inc. (10/13 - present).
 **
 **		Claus Assmann,
-**			Sendmail, Inc. (12/98 - present).
+**			Sendmail, Inc. (12/98 - 10/13).
+**			Proofpoint, Inc. (10/13 - present).
 */
 
 char		*FullName;	/* sender's full name */
@@ -115,8 +111,8 @@
 #if SASL
 static sasl_callback_t srvcallbacks[] =
 {
-	{	SASL_CB_VERIFYFILE,	&safesaslfile,	NULL	},
-	{	SASL_CB_PROXY_POLICY,	&proxy_policy,	NULL	},
+	{	SASL_CB_VERIFYFILE,	(sasl_callback_ft)&safesaslfile,	NULL	},
+	{	SASL_CB_PROXY_POLICY,	(sasl_callback_ft)&proxy_policy,	NULL	},
 	{	SASL_CB_LIST_END,	NULL,		NULL	}
 };
 #endif /* SASL */
@@ -310,6 +306,9 @@
 	SubmitMode = SUBMIT_UNKNOWN;
 #if _FFR_LOCAL_DAEMON
 	LocalDaemon = false;
+# if NETINET6
+	V6LoopbackAddrFound = false;
+# endif /* NETINET6 */
 #endif /* _FFR_LOCAL_DAEMON */
 #if XDEBUG
 	checkfd012("after openlog");
@@ -1314,7 +1313,7 @@
 		(void) getfallbackmxrr(FallbackMX);
 #endif /* NAMED_BIND */
 
-	if (SuperSafe == SAFE_INTERACTIVE && CurEnv->e_sendmode != SM_DELIVER)
+	if (SuperSafe == SAFE_INTERACTIVE && !SM_IS_INTERACTIVE(CurEnv->e_sendmode))
 	{
 		(void) sm_io_fprintf(smioout, SM_TIME_DEFAULT,
 				     "WARNING: SuperSafe=interactive should only be used with\n         DeliveryMode=interactive\n");
@@ -2106,7 +2105,7 @@
 							     "> ");
 				(void) sm_io_flush(smioout, SM_TIME_DEFAULT);
 				if (sm_io_fgets(smioin, SM_TIME_DEFAULT, buf,
-						sizeof(buf)) == NULL)
+						sizeof(buf)) < 0)
 					testmodeline("/quit", &MainEnvelope);
 				p = strchr(buf, '\n');
 				if (p != NULL)
@@ -2156,7 +2155,13 @@
 	if (tls_ok)
 	{
 		/* basic TLS initialization */
-		tls_ok = init_tls_library();
+		tls_ok = init_tls_library(FipsMode);
+		if (!tls_ok && FipsMode)
+		{
+			(void) sm_io_fprintf(smioout, SM_TIME_DEFAULT,
+				     "ERROR: FIPSMode failed to initialize\n");
+			exit(EX_USAGE);
+		}
 	}
 
 	if (!tls_ok && (OpMode == MD_QUEUERUN || OpMode == MD_DELIVER))
@@ -2564,6 +2569,10 @@
 		authinfo = getauthinfo(sm_io_getinfo(InChannel, SM_IO_WHAT_FD,
 						     NULL), &forged);
 		macdefine(&BlankEnvelope.e_macro, A_TEMP, '_', authinfo);
+		if (tTd(75, 9))
+			sm_syslog(LOG_INFO, NOQID,
+				"main: where=after_getauthinfo, RealHostAddr=%s",
+				anynet_ntoa(&RealHostAddr));
 
 		/* at this point we are in a child: reset state */
 		sm_rpool_free(MainEnvelope.e_rpool);
@@ -2830,7 +2839,7 @@
 
 		/* set message size */
 		(void) sm_snprintf(buf, sizeof(buf), "%ld",
-				   MainEnvelope.e_msgsize);
+				   PRT_NONNEGL(MainEnvelope.e_msgsize));
 		macdefine(&MainEnvelope.e_macro, A_TEMP,
 			  macid("{msg_size}"), buf);
 
@@ -3196,7 +3205,7 @@
 **	may resend a message.
 **
 **	Parameters:
-**		none.
+**		sig -- incoming signal.
 **
 **	Returns:
 **		none.
@@ -3207,8 +3216,6 @@
 **	NOTE:	THIS CAN BE CALLED FROM A SIGNAL HANDLER.  DO NOT ADD
 **		ANYTHING TO THIS ROUTINE UNLESS YOU KNOW WHAT YOU ARE
 **		DOING.
-**
-**		XXX: More work is needed for this signal handler.
 */
 
 /* ARGSUSED */
@@ -3223,38 +3230,34 @@
 	errno = save_errno;
 	CHECK_CRITICAL(sig);
 	sm_allsignals(true);
+	IntSig = true;
 
-	if (sig != 0 && LogLevel > 79)
-		sm_syslog(LOG_DEBUG, CurEnv->e_id, "interrupt");
 	FileName = NULL;
 
 	/* Clean-up on aborted stdin message submission */
-	if (CurEnv->e_id != NULL &&
-	    (OpMode == MD_SMTP ||
+	if  (OpMode == MD_SMTP ||
 	     OpMode == MD_DELIVER ||
-	     OpMode == MD_ARPAFTP))
+	     OpMode == MD_ARPAFTP)
 	{
-		register ADDRESS *q;
+		if (CurEnv->e_id != NULL)
+		{
+			char *fn;
 
-		/* don't return an error indication */
-		CurEnv->e_to = NULL;
-		CurEnv->e_flags &= ~EF_FATALERRS;
-		CurEnv->e_flags |= EF_CLRQUEUE;
-
-		/*
-		**  Spin through the addresses and
-		**  mark them dead to prevent bounces
-		*/
-
-		for (q = CurEnv->e_sendqueue; q != NULL; q = q->q_next)
-			q->q_state = QS_DONTSEND;
-
-		drop = true;
+			fn = queuename(CurEnv, DATAFL_LETTER);
+			if (fn != NULL)
+				(void) unlink(fn);
+			fn = queuename(CurEnv, ANYQFL_LETTER);
+			if (fn != NULL)
+				(void) unlink(fn);
+		}
+		_exit(EX_OK);
+		/* NOTREACHED */
 	}
-	else if (OpMode != MD_TEST)
-	{
+
+	if (sig != 0 && LogLevel > 79)
+		sm_syslog(LOG_DEBUG, CurEnv->e_id, "interrupt");
+	if (OpMode != MD_TEST)
 		unlockqueue(CurEnv);
-	}
 
 	finis(drop, false, EX_OK);
 	/* NOTREACHED */
@@ -4483,6 +4486,25 @@
 			(void) sm_io_fprintf(smioout, SM_TIME_DEFAULT,
 					     "ul = %lu\n", ul);
 		}
+#if NETINET || NETINET6
+		else if (sm_strcasecmp(&line[1], "gethostbyname") == 0)
+		{
+			int family = AF_INET;
+
+			q = strpbrk(p, " \t");
+			if (q != NULL)
+			{
+				while (isascii(*q) && isspace(*q))
+					*q++ = '\0';
+# if NETINET6
+				if (*q != '\0' && (strcmp(q, "inet6") == 0 ||
+						   strcmp(q, "AAAA") == 0))
+					family = AF_INET6;
+# endif /* NETINET6 */
+			}
+			(void) sm_gethostbyname(p, family);
+		}
+#endif /* NETINET || NETINET6 */
 		else
 		{
 			(void) sm_io_fprintf(smioout, SM_TIME_DEFAULT,
--- old/usr/src/cmd/sendmail/src/map.c	Sat Feb  6 15:36:45 2016
+++ new/usr/src/cmd/sendmail/src/map.c	Sat Feb  6 15:36:45 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2008 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2008 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1992, 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1992, 1993
@@ -11,14 +11,9 @@
  *
  */
 
-/*
- * Copyright 1996-2007 Sun Microsystems, Inc.  All rights reserved.
- * Use is subject to license terms.
- */
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: map.c,v 8.705 2009/08/11 22:22:40 ca Exp $")
+SM_RCSID("@(#)$Id: map.c,v 8.713 2013-11-22 20:51:55 ca Exp $")
 
 #if LDAPMAP
 # include <sm/ldap.h>
@@ -2888,6 +2883,9 @@
 # undef T_UNSPEC	/* symbol conflict in nis.h -> ... -> sys/tiuser.h */
 # include <rpcsvc/nis.h>
 # include <rpcsvc/nislib.h>
+# ifndef NIS_TABLE_OBJ
+#  define NIS_TABLE_OBJ TABLE_OBJ
+# endif /* NIS_TABLE_OBJ */
 
 # define EN_col(col)	zo_data.objdata_u.en_data.en_cols.en_cols_val[(col)].ec_value.ec_value_val
 # define COL_NAME(res,i)	((res->objects.objects_val)->TA_data.ta_cols.ta_cols_val)[i].tc_name
@@ -2975,7 +2973,7 @@
 	}
 
 	if (NIS_RES_NUMOBJ(res) != 1 ||
-	    (NIS_RES_OBJECT(res)->zo_data.zo_type != TABLE_OBJ))
+	    (NIS_RES_OBJECT(res)->zo_data.zo_type != NIS_TABLE_OBJ))
 	{
 		if (tTd(38, 10))
 			sm_dprintf("nisplus_map_open: %s is not a table\n", qbuf);
@@ -3439,7 +3437,7 @@
 		{
 			if (LogLevel > 1)
 				sm_syslog(LOG_NOTICE, CurEnv->e_id,
-					  "timeout conning to LDAP server %.100s",
+					  "timeout connecting to LDAP server %.100s",
 					  id);
 		}
 
@@ -3768,11 +3766,11 @@
 		if (!bitset(MF_OPTIONAL, map->map_mflags))
 		{
 			if (bitset(MF_NODEFER, map->map_mflags))
-				syserr("Error getting LDAP results in map %s",
-				       map->map_mname);
+				syserr("Error getting LDAP results, map=%s, name=%s",
+				       map->map_mname, name);
 			else
-				syserr("451 4.3.5 Error getting LDAP results in map %s",
-				       map->map_mname);
+				syserr("451 4.3.5 Error getting LDAP results, map=%s, name=%s",
+				       map->map_mname, name);
 		}
 		errno = save_errno;
 		return NULL;
@@ -3786,7 +3784,7 @@
 	{
 		if (LogLevel > 9)
 			sm_syslog(LOG_INFO, CurEnv->e_id,
-				  "ldap %.100s => %s", name,
+				  "ldap=%s, %.100s=>%s", map->map_mname, name,
 				  vp == NULL ? "<NULL>" : vp);
 		if (bitset(MF_MATCHONLY, map->map_mflags))
 			result = map_rewrite(map, name, strlen(name), NULL);
@@ -5839,7 +5837,7 @@
 	key_idx = map->map_keycolno;
 	delim = map->map_coldelim;
 	while (sm_io_fgets(f, SM_TIME_DEFAULT,
-			   linebuf, sizeof(linebuf)) != NULL)
+			   linebuf, sizeof(linebuf)) >= 0)
 	{
 		char *p;
 
@@ -5913,7 +5911,7 @@
 	found = false;
 	while (!found &&
 		sm_io_fgets(f, SM_TIME_DEFAULT,
-			    linebuf, sizeof(linebuf)) != NULL)
+			    linebuf, sizeof(linebuf)) >= 0)
 	{
 		char *p = strpbrk(linebuf, "#\n");
 
@@ -5990,7 +5988,7 @@
 /*
 **  STAB_MAP_OPEN -- initialize (reads data file)
 **
-**	This is a wierd case -- it is only intended as a fallback for
+**	This is a weird case -- it is only intended as a fallback for
 **	aliases.  For this reason, opens for write (only during a
 **	"newaliases") always fails, and opens for read open the
 **	actual underlying text file instead of the database.
@@ -7368,6 +7366,87 @@
 	return NULL;
 }
 
+#if _FFR_ARPA_MAP
+char *
+arpa_map_lookup(map, name, av, statp)
+	MAP *map;
+	char *name;
+	char **av;
+	int *statp;
+{
+	int r;
+	char *rval;
+	char result[128];	/* IPv6: 64 + 10 + 1 would be enough */
+
+	if (tTd(38, 2))
+		sm_dprintf("arpa_map_lookup: key '%s'\n", name);
+	*statp = EX_DATAERR;
+	r = 1;
+	memset(result, '\0', sizeof(result));
+	rval = NULL;
+
+# if NETINET6
+	if (sm_strncasecmp(name, "IPv6:", 5) == 0)
+	{
+		struct in6_addr in6_addr;
+
+		r = anynet_pton(AF_INET6, name, &in6_addr);
+		if (r == 1)
+		{
+			static char hex_digits[] =
+				{ '0', '1', '2', '3', '4', '5', '6', '7', '8',
+				  '9', 'a', 'b', 'c', 'd', 'e', 'f' };
+
+			unsigned char *src;
+			char *dst;
+			int i;
+
+			src = (unsigned char *) &in6_addr;
+			dst = result;
+			for (i = 15; i >= 0; i--) {
+				*dst++ = hex_digits[src[i] & 0x0f];
+				*dst++ = '.';
+				*dst++ = hex_digits[(src[i] >> 4) & 0x0f];
+				if (i > 0)
+					*dst++ = '.';
+			}
+			*statp = EX_OK;
+		}
+	}
+	else
+# endif /* NETINET6 */
+# if NETINET
+	{
+		struct in_addr in_addr;
+
+		r = anynet_pton(AF_INET, name, &in_addr);
+		if (r == 1)
+		{
+			unsigned char *src;
+
+			src = (unsigned char *) &in_addr;
+			(void) snprintf(result, sizeof(result),
+				"%u.%u.%u.%u",
+				src[3], src[2], src[1], src[0]);
+			*statp = EX_OK;
+		}
+	}
+# endif /* NETINET */
+	if (r < 0)
+		*statp = EX_UNAVAILABLE;
+	if (tTd(38, 2))
+		sm_dprintf("arpa_map_lookup: r=%d, result='%s'\n", r, result);
+	if (*statp == EX_OK)
+	{
+		if (bitset(MF_MATCHONLY, map->map_mflags))
+			rval = map_rewrite(map, name, strlen(name), NULL);
+		else
+			rval = map_rewrite(map, result, strlen(result), av);
+	}
+	return rval;
+}
+#endif /* _FFR_ARPA_MAP */
+
 #if SOCKETMAP
 
 # if NETINET || NETINET6
--- old/usr/src/cmd/sendmail/src/map.h	Sat Feb  6 15:36:45 2016
+++ new/usr/src/cmd/sendmail/src/map.h	Sat Feb  6 15:36:46 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2006 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 2006 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  *
  * By using this file, you agree to the terms and conditions set
@@ -6,11 +6,9 @@
  * forth in the LICENSE file which can be found at the top level of
  * the sendmail distribution.
  *
- *	$Id: map.h,v 8.3 2006/12/19 19:49:51 ca Exp $
+ *	$Id: map.h,v 8.4 2013-11-22 20:51:56 ca Exp $
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #ifndef _MAP_H
 # define _MAP_H 1
 
--- old/usr/src/cmd/sendmail/src/mci.c	Sat Feb  6 15:36:46 2016
+++ new/usr/src/cmd/sendmail/src/mci.c	Sat Feb  6 15:36:46 2016
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1998-2005 Sendmail, Inc. and its suppliers.
+ * Copyright (c) 1998-2005, 2010 Proofpoint, Inc. and its suppliers.
  *	All rights reserved.
  * Copyright (c) 1995-1997 Eric P. Allman.  All rights reserved.
  * Copyright (c) 1988, 1993
@@ -11,11 +11,9 @@
  *
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include <sendmail.h>
 
-SM_RCSID("@(#)$Id: mci.c,v 8.221 2007/11/13 23:44:25 gshapiro Exp $")
+SM_RCSID("@(#)$Id: mci.c,v 8.225 2013-11-22 20:51:56 ca Exp $")
 
 #if NETINET || NETINET6
 # include <arpa/inet.h>
@@ -290,7 +288,33 @@
 			mci_uncache(&MciCache[i], doquit);
 	}
 }
+
 /*
+**  MCI_CLR_EXTENSIONS -- clear knowledge about SMTP extensions
+**
+**	Parameters:
+**		mci -- the connection to clear.
+**
+**	Returns:
+**		none.
+*/
+
+void
+mci_clr_extensions(mci)
+	MCI *mci;
+{
+	if (mci == NULL)
+		return;
+
+	mci->mci_flags &= ~MCIF_EXTENS;
+	mci->mci_maxsize = 0;
+	mci->mci_min_by = 0;
+#if SASL
+	mci->mci_saslcap = NULL;
+#endif /* SASL */
+}
+
+/*
 **  MCI_GET -- get information about a particular host
 **
 **	Parameters:
@@ -569,6 +593,7 @@
 	{ MCIF_CVT7TO8,		"CVT7TO8"	},
 	{ MCIF_INMIME,		"INMIME"	},
 	{ MCIF_AUTH,		"AUTH"		},
+	{ MCIF_AUTH2,		"AUTH2"		},
 	{ MCIF_AUTHACT,		"AUTHACT"	},
 	{ MCIF_ENHSTAT,		"ENHSTAT"	},
 	{ MCIF_PIPELINED,	"PIPELINED"	},
@@ -947,7 +972,7 @@
 	sm_io_rewind(fp, SM_TIME_DEFAULT);
 	ver = -1;
 	LineNumber = 0;
-	while (sm_io_fgets(fp, SM_TIME_DEFAULT, buf, sizeof(buf)) != NULL)
+	while (sm_io_fgets(fp, SM_TIME_DEFAULT, buf, sizeof(buf)) >= 0)
 	{
 		LineNumber++;
 		p = strchr(buf, '\n');
